# GPL-DRQ

This repository contains research code for the *ICLR 2022* submission *Learning Pessimism for Robust and Efficient Off-Policy Reinforcement Learning*.
This is a minimal repository meant to provide means to reproduce the reported results.
A complete, documented version of our implementation will be open-sourced after review.

This repository is an extension to the open-sourced implementation of the _DrQv2_ algorithm from [Mastering Visual Continuous Control: Improved Data-Augmented Reinforcement Learning](https://arxiv.org/abs/2107.09645), accessible [here](https://github.com/facebookresearch/drqv2).

## Requirements

1) To replicate the experiments in this project you need to install the Mujoco
simulation software with a valid license. You can find instructions [here](https://github.com/openai/mujoco-py).

2) The rest of the requirements can be installed with [conda](https://docs.conda.io/projects/conda/en/latest/user-guide/install/linux.html),
by utilizing the provided environment file:

```setup
conda env create -f conda_env_env.yml
conda activate drqv2
```

## Replicating the results

To execute _GPL-DRQ_ and _GPL-DRQ-Expl+_ in the considered environments, simply run _train.py_ specifying the appropriate agent and environment configurations by setting the _agent_conf_ and _env_conf_ arguments.

We provide a few usage examples:

1) Execute _GPL-DRQ_ in the _Walker run_ task.

```setup
python train.py agent_conf=gpdrqv2 env_conf=walker_run
```

1) Execute _GPL-DRQ-Expl+_ in the _Reach duplo_ task.

```setup
python train.py agent_conf=gpdrqv2_expl env_conf=reach_duplo
```
