# GPL-SAC

This repository contains research code for the *ICLR 2022* submission *Learning Pessimism for Robust and Efficient Off-Policy Reinforcement Learning*.
This is a minimal repository meant to provide means to reproduce the reported results.
A complete, documented of our implementation will be open-sourced after review.

## Requirements

1) To replicate the experiments in this project you need to install the Mujoco
simulation software with a valid license. You can find instructions [here](https://github.com/openai/mujoco-py).

2) The rest of the requirements can be installed with [conda](https://docs.conda.io/projects/conda/en/latest/user-guide/install/linux.html),
by utilizing the provided environment file:

```setup
conda env create -f tf24_env.yml
conda activate tf24
```

## Replicating the results

We provide two alternative ways for experimenting with _GPL-SAC_:

1) Directly from the command line by running _main.py_ and specifying the appropriate _task_name_ argument, e.g.:

```setup
python main.py --task_name 'Humanoid-v2'
```
To test alternative hyper-parameters or run alternative versions of GPL-SAC (such as _GP-QR-SAC_ or _GP-SAC-Expl+_), modify the _params.json_ file appropriately.

2) Interactively, from the GPL-SAC_experiments notebook, accessible by running:

```setup
jupyter notebook
```